package com.steerinfo.inPlantNavigation.util;

import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ExcelIOUtil {
    public  static List<XSSFRow> getRows(String filePath) throws IOException {
        //返回值
        List<XSSFRow> rsultList=new ArrayList<>();
        FileInputStream is = new FileInputStream(filePath);
        XSSFWorkbook workbook=new XSSFWorkbook(is);
        int numberOfSheets = workbook.getNumberOfSheets();
        for (int i=0;i<numberOfSheets;i++){
            XSSFSheet sheetAt = workbook.getSheetAt(i);
            int lastRowNum = sheetAt.getLastRowNum();
            for (int j=1;j<=lastRowNum;j++){
                XSSFRow row = sheetAt.getRow(j);
                rsultList.add(row);
            }
        }
        return rsultList;
    }

    public  static List<HSSFRow> getRowsByXls(String filePath,int ignore) throws IOException {
        //返回值
        List<HSSFRow> rsultList=new ArrayList<>();
        FileInputStream is = new FileInputStream(filePath);
        HSSFWorkbook workbook=new HSSFWorkbook(is);
        int numberOfSheets = workbook.getNumberOfSheets();
        for (int i=0;i<numberOfSheets;i++){
            HSSFSheet sheetAt = workbook.getSheetAt(i);
            int lastRowNum = sheetAt.getLastRowNum();//最后一行下标
            //j=ignore行开始获取数据
            for (int j=ignore;j<=lastRowNum;j++){
                HSSFRow row = sheetAt.getRow(j);
                rsultList.add(row);
            }
        }
        return rsultList;
    }
}
